# Class OjListView

The component WebElement for oj-list-view. Do not instantiate this class directly, instead, use ojListView.

#### Hierarchy

- OjListViewBase
  - OjListView

#####
Index

### Constructors

constructor

### Methods

changeCurrentItem
changeScrollPosition
changeSelected
changeSelection
clear
click
findElement
findElements
findItem
getAs
getAttribute
getCssValue
getCurrentItem
getDisplay
getDnd
getDrillMode
getDriver
getFirstSelectedItem
getGridlines
getGroupHeaderPosition
getId
getItem
getLocation
getProperty
getRect
getScrollPolicy
getScrollPolicyOptions
getScrollPosition
getScrollToKey
getSelected
getSelection
getSelectionMode
getSelectionRequired
getShadowRoot
getSize
getTagName
getText
getTranslations
hasSize
hasVisibility
isDisplayed
isEnabled
isSelected
sendKeys
serialize
setProperty
submit
takeScreenshot
whenBusyContextReady
whenReady
buildId
equals
extractId
isId

## Constructors

### constructor

- new OjListView(el, locators): OjListView

- Constructor. Pass an instance of WebDriver's WebElement that represents the DOM node on which we"ll perform operations.

  #### Parameters

  - ##### el: WebElement

    The basic WebElement with which this WebElement will work.

  - ##### locators: ElementLocators

  #### Returns OjListView

  Inherited from OjListViewBase.constructor

## Methods

### changeCurrentItem

- changeCurrentItem(currentItem): Promise<void>

- Sets the value of `currentItem` property. Specifies the key of the item that should have keyboard focus. See the Help documentation for more information.

  #### Parameters

  - ##### currentItem: any

    The value to set for `currentItem`

  #### Returns Promise<void>

  Inherited from OjListViewBase.changeCurrentItem

### changeScrollPosition

- changeScrollPosition(scrollPosition): Promise<void>

- Sets the value of `scrollPosition` property. Specifies the current scroll position of the list. See the Help documentation for more information.

  #### Parameters

  - ##### scrollPosition: ScrollPosition

    The value to set for `scrollPosition`

  #### Returns Promise<void>

  Inherited from OjListViewBase.changeScrollPosition

### changeSelected

- changeSelected<K>(selected): Promise<void>

- Sets the value of "selected" property. Specifies the current selected items in the listview. See the Help documentation for more information.

  ### Typeparam

  K Type of keys

  #### Type Parameters

  - #### K

  #### Parameters

  - ##### selected: K[]

    The value to set for "selected"

  #### Returns Promise<void>

### changeSelection

- changeSelection(selection): Promise<void>

- Sets the value of `selection` property. Specifies the current selections in the list. See the Help documentation for more information.

  ### Deprecated

  Since 7.0.0. Use selected attribute instead.

  #### Parameters

  - ##### selection: any[]

    The value to set for `selection`

  #### Returns Promise<void>

  Inherited from OjListViewBase.changeSelection

### clear

- clear(): Promise<void>

- ### Inherit Doc

  #### Returns Promise<void>

  Inherited from OjListViewBase.clear

### click

- click(): Promise<void>

- ### Inherit Doc

  #### Returns Promise<void>

  Inherited from OjListViewBase.click

### findElement

- findElement(locator): WebElementPromise

- ### Inherit Doc

  #### Parameters

  - ##### locator: Locator

  #### Returns WebElementPromise

  Inherited from OjListViewBase.findElement

### findElements

- findElements(locator): Promise<WebElement[]>

- ### Inherit Doc

  #### Parameters

  - ##### locator: Locator

  #### Returns Promise<WebElement[]>

  Inherited from OjListViewBase.findElements

### findItem

- findItem<T>(itemLocator): Promise<SlotProxy>

- Retrieve a SlotProxy which represents a single listview item.

  #### Type Parameters

  - #### T

  #### Parameters

  - ##### itemLocator: {
    key: T;
    }

    - ##### key: T

  #### Returns Promise<SlotProxy>

### getAs

- getAs(): Promise<string>

- Gets the value of `as` property. Specifies the alias for the current item when referenced inside the item template.

  ### Deprecated

  Since 6.2.0. Set the alias directly on the template element using the data-oj-as attribute instead.

  #### Returns Promise<string>

  The value of `as` property.

  Inherited from OjListViewBase.getAs

### getAttribute

- getAttribute(attributeName): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### attributeName: string

  #### Returns Promise<string>

  Inherited from OjListViewBase.getAttribute

### getCssValue

- getCssValue(cssStyleProperty): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### cssStyleProperty: string

  #### Returns Promise<string>

  Inherited from OjListViewBase.getCssValue

### getCurrentItem

- getCurrentItem(): Promise<any>

- Gets the value of `currentItem` property. Specifies the key of the item that should have keyboard focus. See the Help documentation for more information.

  #### Returns Promise<any>

  The value of `currentItem` property.

  Inherited from OjListViewBase.getCurrentItem

### getDisplay

- getDisplay(): Promise<string>

- Gets the value of `display` property. Specifies how the items should be displayed.

  #### Returns Promise<string>

  The value of `display` property.

  Inherited from OjListViewBase.getDisplay

### getDnd

- getDnd(): Promise<Dnd>

- Gets the value of `dnd` property. Customizes the drag and drop functionality. See the Help documentation for more information.

  #### Returns Promise<Dnd>

  The value of `dnd` property.

  Inherited from OjListViewBase.getDnd

### getDrillMode

- getDrillMode(): Promise<string>

- Gets the value of `drillMode` property. Specifies whether expand or collapse operations are allowed.

  #### Returns Promise<string>

  The value of `drillMode` property.

  Inherited from OjListViewBase.getDrillMode

### getDriver

- getDriver(): WebDriver

- #### Returns WebDriver

  The parent driver for this instance.

  Inherited from OjListViewBase.getDriver

### getFirstSelectedItem

- getFirstSelectedItem(): Promise<object>

- Gets the value of `firstSelectedItem` property. Specifies the key and data of the first selected item. See the Help documentation for more information.

  #### Returns Promise<object>

  The value of `firstSelectedItem` property.

  Inherited from OjListViewBase.getFirstSelectedItem

### getGridlines

- getGridlines(): Promise<Gridlines>

- Gets the value of `gridlines` property. Customizes the functionality of how gridlines are shown in various parts of the list.

  #### Returns Promise<Gridlines>

  The value of `gridlines` property.

  Inherited from OjListViewBase.getGridlines

### getGroupHeaderPosition

- getGroupHeaderPosition(): Promise<string>

- Gets the value of `groupHeaderPosition` property. Specifies whether group header should stick to the top as user scrolls.

  #### Returns Promise<string>

  The value of `groupHeaderPosition` property.

  Inherited from OjListViewBase.getGroupHeaderPosition

### getId

- getId(): Promise<string>

- #### Returns Promise<string>

  A promise that resolves to the server-assigned opaque ID assigned to this element.

  Inherited from OjListViewBase.getId

### getItem

- getItem(): Promise<Item>

- Gets the value of `item` property. Customizes the functionality of each item on the list.

  #### Returns Promise<Item>

  The value of `item` property.

  Inherited from OjListViewBase.getItem

### getLocation

- getLocation(): Promise<ILocation>

- ### Inherit Doc

  #### Returns Promise<ILocation>

  Inherited from OjListViewBase.getLocation

### getProperty

- getProperty<T>(propertyName): Promise<T>

- Get a named property value from this component. This function will wait for the application's busy context to complete before attempting to get the property value.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The name of the property

  #### Returns Promise<T>

  A Promise that yields a value for the named property.

  Inherited from OjListViewBase.getProperty

### getRect

- getRect(): Promise<IRectangle>

- ### Inherit Doc

  #### Returns Promise<IRectangle>

  Inherited from OjListViewBase.getRect

### getScrollPolicy

- getScrollPolicy(): Promise<string>

- Gets the value of `scrollPolicy` property. Specifies how data are fetched as user scrolls down the list.

  #### Returns Promise<string>

  The value of `scrollPolicy` property.

  Inherited from OjListViewBase.getScrollPolicy

### getScrollPolicyOptions

- getScrollPolicyOptions(): Promise<unknown>

- Gets the value of `scrollPolicyOptions` property. Specifies fetch options for scrolling behaviors that trigger data fetches. See the Help documentation for more information.

  #### Returns Promise<unknown>

  The value of `scrollPolicyOptions` property.

  Inherited from OjListViewBase.getScrollPolicyOptions

### getScrollPosition

- getScrollPosition(): Promise<ScrollPosition>

- Gets the value of `scrollPosition` property. Specifies the current scroll position of the list. See the Help documentation for more information.

  #### Returns Promise<ScrollPosition>

  The value of `scrollPosition` property.

  Inherited from OjListViewBase.getScrollPosition

### getScrollToKey

- getScrollToKey(): Promise<string>

- Gets the value of `scrollToKey` property. Specifies the behavior when ListView needs to scroll to a position based on an item key.

  #### Returns Promise<string>

  The value of `scrollToKey` property.

  Inherited from OjListViewBase.getScrollToKey

### getSelected

- getSelected<K>(): Promise<K[]>

- Gets the value of "selected" property. Retrieves the current selected items in the listview. See the Help documentation for more information.

  ### Typeparam

  K Type of keys

  #### Type Parameters

  - #### K

  #### Returns Promise<K[]>

  The value of "selected" property.

### getSelection

- getSelection(): Promise<any[]>

- Gets the value of `selection` property. Specifies the current selections in the list. See the Help documentation for more information.

  ### Deprecated

  Since 7.0.0. Use selected attribute instead.

  #### Returns Promise<any[]>

  The value of `selection` property.

  Inherited from OjListViewBase.getSelection

### getSelectionMode

- getSelectionMode(): Promise<string>

- Gets the value of `selectionMode` property. Specifies the selection mode.

  #### Returns Promise<string>

  The value of `selectionMode` property.

  Inherited from OjListViewBase.getSelectionMode

### getSelectionRequired

- getSelectionRequired(): Promise<boolean>

- Gets the value of `selectionRequired` property. Specifies whether selection is required on the ListView.

  #### Returns Promise<boolean>

  The value of `selectionRequired` property.

  Inherited from OjListViewBase.getSelectionRequired

### getShadowRoot

- getShadowRoot(): ShadowRootPromise

- Get the shadow root of the current web element.

  #### Returns ShadowRootPromise

  A promise that will be resolved with the elements shadow root or rejected with NoSuchShadowRootError

  Inherited from OjListViewBase.getShadowRoot

### getSize

- getSize(): Promise<ISize>

- ### Inherit Doc

  #### Returns Promise<ISize>

  Inherited from OjListViewBase.getSize

### getTagName

- getTagName(): Promise<string>

- Schedules a command to query for the tag/node name of this element.

  #### Returns Promise<string>

  A promise that will be resolved with the element's tag name.

  Inherited from OjListViewBase.getTagName

### getText

- getText(): Promise<string>

- ### Inherit Doc

  #### Returns Promise<string>

  Inherited from OjListViewBase.getText

### getTranslations

- getTranslations(): Promise<Translations>

- Gets the value of `translations` property. A collection of translated resources from the translation bundle, or null if this component has no resources.

  #### Returns Promise<Translations>

  The value of `translations` property.

  Inherited from OjListViewBase.getTranslations

### `Protected` hasSize

- hasSize(): Condition<Promise<boolean>>

- Create a wait condition that is satisfied when the element's DOM has a non-zero size.

  ### Deprecated

  Since 11.0.0. Call the appropriate WebElement method to test the size of the element.

  #### Returns Condition<Promise<boolean>>

  The Condition to be used with driver.wait() that's satisfied when the element's DOM has a non-zero size.

  Inherited from OjListViewBase.hasSize

### `Protected` hasVisibility

- hasVisibility(): Condition<Promise<boolean>>

- Create a wait condition that is satisfid when the element is visible. The condition is satisfied when the element is displayed, as reported by #isDisplayed, and is scrolled into view. This is method is deprecated. Use WebElement.isDisplayed instead to test the display of the element, and scroll it into view if necessary.

  ### Deprecated

  #### Returns Condition<Promise<boolean>>

  Inherited from OjListViewBase.hasVisibility

### isDisplayed

- isDisplayed(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjListViewBase.isDisplayed

### isEnabled

- isEnabled(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjListViewBase.isEnabled

### isSelected

- isSelected(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjListViewBase.isSelected

### sendKeys

- sendKeys(...varArgs): Promise<void>

- ### Inherit Doc

  #### Parameters

  - ##### `Rest` ...varArgs: (string | number | Promise<string | number>)[]

  #### Returns Promise<void>

  Inherited from OjListViewBase.sendKeys

### serialize

- serialize(): Promise<IWebElementId>

- #### Returns Promise<IWebElementId>

  Inherited from OjListViewBase.serialize

### `Protected` setProperty

- setProperty<T>(propertyName, value): Promise<void>

- Set a property value on the remote element. This function first waits for the BusyContext to clear before setting the property, then after setting, waits again to ensure that no additional busy states were created due to the property setting.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The property name to set

  - ##### value: T

    The value to set for the property

  #### Returns Promise<void>

  A Promise which resolves when the remote property has been set to the value. Any value returned from the call to set the remote property is returned in the Promise.

  Inherited from OjListViewBase.setProperty

### submit

- submit(): Promise<void>

- ### Inherit Doc

  #### Returns Promise<void>

  Inherited from OjListViewBase.submit

### takeScreenshot

- takeScreenshot(optScroll?): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### `Optional` optScroll: boolean

  #### Returns Promise<string>

  Inherited from OjListViewBase.takeScreenshot

### whenBusyContextReady

- whenBusyContextReady(): Promise<void>

- Returns a Promise that is resolved when the application's busy state reports ready. This method checks only that the application's busy context is ready, and not that the DOM element is actually displayed or has a physical size, such as is the case with #whenReady. Operations which are read-only in nature should call this method prior to execution.

  #### Returns Promise<void>

  A Promise which is resolved when the page's busy state is ready.

  Inherited from OjListViewBase.whenBusyContextReady

### whenReady

- whenReady(): Promise<void>

- Returns a Promise that is resolved when the element is ready for interaction--it is visible, has a size, and the app's busy context is ready. Operations on the DOM which rely on its physical location and size to be in a "ready" state should use this command, such as clicking, sending keys, locating child elements, and so on.

  #### Returns Promise<void>

  A Promise that's resolved when all conditions are met.

  Inherited from OjListViewBase.whenReady

### `Static` buildId

- buildId(id, opt_noLegacy?): IWebElementId

- #### Parameters

  - ##### id: string

    The raw ID.

  - ##### `Optional` opt_noLegacy: boolean

    Whether to exclude the legacy element key.

  #### Returns IWebElementId

  The element ID for use with WebDriver's wire protocol.

  Inherited from OjListViewBase.buildId

### `Static` equals

- equals(a, b): Promise<boolean>

- Compares two WebElements for equality.

  #### Parameters

  - ##### a: WebElement

    A WebElement.

  - ##### b: WebElement

    A WebElement.

  #### Returns Promise<boolean>

  A promise that will be resolved to whether the two WebElements are equal.

  Inherited from OjListViewBase.equals

### `Static` extractId

- extractId(obj): string

- Extracts the encoded WebElement ID from the object.

  ### Throws

  if the object is not a valid encoded ID.

  #### Parameters

  - ##### obj: IWebElementId

    The object to extract the ID from.

  #### Returns string

  the extracted ID.

  Inherited from OjListViewBase.extractId

### `Static` isId

- isId(obj): boolean

- #### Parameters

  - ##### obj: IWebElementId

    the object to test.

  #### Returns boolean

  whether the object is a valid encoded WebElement ID.

  Inherited from OjListViewBase.isId

Generated using TypeDoc